# Copyright (C) 2006 Daiki Ueno <ueno@unixuser.org>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

require 'pathname'
require 'rbconfig'
arch = Config::CONFIG['arch']
base = Pathname.new(__FILE__).dirname
$LOAD_PATH.unshift(base + arch)

begin
  require 'treil.so'
rescue LoadError
  if (base + '../libtreil.la').exist?
    $stderr.puts("Try `libtool --mode=execute -dlopen #{base + '../libtreil.la'} #{$0} #{ARGV.join(' ')}'")
  end
  raise
end

module Treil
  class Tree
    def escape_path
      path.collect {|name| name.gsub(%r{[\t\r\n%/]}) {'%%%02X' % $&[0]}}.join('/')
    end
  end
end

require 'treil/reader'
require 'treil/writer'
require 'treil/config'
